<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\StructType\\UPSSecurity',
            'UsernameToken' => '\\StructType\\UsernameToken',
            'ServiceAccessToken' => '\\StructType\\ServiceAccessToken',
            'Errors' => '\\StructType\\Errors',
            'ErrorDetailType' => '\\StructType\\ErrorDetailType',
            'ElementLevelInformationType' => '\\StructType\\ElementLevelInformationType',
            'ElementIdentifierType' => '\\StructType\\ElementIdentifierType',
            'CodeType' => '\\StructType\\CodeType',
            'AdditionalInfoType' => '\\StructType\\AdditionalInfoType',
            'AdditionalCodeDescType' => '\\StructType\\AdditionalCodeDescType',
            'LocationType' => '\\StructType\\LocationType',
            'ClientInformationType' => '\\StructType\\ClientInformationType',
            'Property' => '\\StructType\\Property',
            'RequestType' => '\\StructType\\RequestType',
            'TransactionReferenceType' => '\\StructType\\TransactionReferenceType',
            'ResponseType' => '\\StructType\\ResponseType',
            'CodeDescriptionType' => '\\StructType\\CodeDescriptionType',
            'DetailType' => '\\StructType\\DetailType',
            'InternationalFormType' => '\\StructType\\InternationalFormType',
            'UPSPremiumCareFormType' => '\\StructType\\UPSPremiumCareFormType',
            'LanguageForUPSPremiumCareType' => '\\StructType\\LanguageForUPSPremiumCareType',
            'UserCreatedFormType' => '\\StructType\\UserCreatedFormType',
            'CN22FormType' => '\\StructType\\CN22FormType',
            'CN22ContentType' => '\\StructType\\CN22ContentType',
            'ContactType' => '\\StructType\\ContactType',
            'ForwardAgentType' => '\\StructType\\ForwardAgentType',
            'AddressType' => '\\StructType\\AddressType',
            'UltimateConsigneeType' => '\\StructType\\UltimateConsigneeType',
            'IntermediateConsigneeType' => '\\StructType\\IntermediateConsigneeType',
            'ProducerType' => '\\StructType\\ProducerType',
            'ProductType' => '\\StructType\\ProductType',
            'ExcludeFromFormType' => '\\StructType\\ExcludeFromFormType',
            'UnitType' => '\\StructType\\UnitType',
            'PackingListInfoType' => '\\StructType\\PackingListInfoType',
            'PackageAssociatedType' => '\\StructType\\PackageAssociatedType',
            'UnitOfMeasurementType' => '\\StructType\\UnitOfMeasurementType',
            'NetCostDateType' => '\\StructType\\NetCostDateType',
            'ProductWeightType' => '\\StructType\\ProductWeightType',
            'ScheduleBType' => '\\StructType\\ScheduleBType',
            'IFChargesType' => '\\StructType\\IFChargesType',
            'OtherChargesType' => '\\StructType\\OtherChargesType',
            'BlanketPeriodType' => '\\StructType\\BlanketPeriodType',
            'LicenseType' => '\\StructType\\LicenseType',
            'SoldToType' => '\\StructType\\SoldToType',
            'PhoneType' => '\\StructType\\PhoneType',
            'DDTCInformationType' => '\\StructType\\DDTCInformationType',
            'EEILicenseType' => '\\StructType\\EEILicenseType',
            'EEIFilingOptionType' => '\\StructType\\EEIFilingOptionType',
            'UPSFiledType' => '\\StructType\\UPSFiledType',
            'ShipperFiledType' => '\\StructType\\ShipperFiledType',
            'EEIInformationType' => '\\StructType\\EEIInformationType',
            'POAType' => '\\StructType\\POAType',
            'UltimateConsigneeTypeType' => '\\StructType\\UltimateConsigneeTypeType',
            'ShipmentRequest' => '\\StructType\\ShipmentRequest',
            'ShipConfirmRequest' => '\\StructType\\ShipConfirmRequest',
            'ShipAcceptRequest' => '\\StructType\\ShipAcceptRequest',
            'ShipmentResponse' => '\\StructType\\ShipmentResponse',
            'ShipConfirmResponse' => '\\StructType\\ShipConfirmResponse',
            'ShipAcceptResponse' => '\\StructType\\ShipAcceptResponse',
            'ShipmentType' => '\\StructType\\ShipmentType',
            'ShipmentServiceOptions' => '\\StructType\\ShipmentServiceOptions',
            'PromotionalDiscountInformationType' => '\\StructType\\PromotionalDiscountInformationType',
            'ReturnServiceType' => '\\StructType\\ReturnServiceType',
            'ShipperType' => '\\StructType\\ShipperType',
            'CompanyInfoType' => '\\StructType\\CompanyInfoType',
            'ShipPhoneType' => '\\StructType\\ShipPhoneType',
            'ShipAddressType' => '\\StructType\\ShipAddressType',
            'ShipToType' => '\\StructType\\ShipToType',
            'ShipToAddressType' => '\\StructType\\ShipToAddressType',
            'ShipFromType' => '\\StructType\\ShipFromType',
            'PrepaidType' => '\\StructType\\PrepaidType',
            'BillShipperType' => '\\StructType\\BillShipperType',
            'CreditCardType' => '\\StructType\\CreditCardType',
            'CreditCardAddressType' => '\\StructType\\CreditCardAddressType',
            'BillThirdPartyChargeType' => '\\StructType\\BillThirdPartyChargeType',
            'AccountAddressType' => '\\StructType\\AccountAddressType',
            'FreightCollectType' => '\\StructType\\FreightCollectType',
            'BillReceiverType' => '\\StructType\\BillReceiverType',
            'BillReceiverAddressType' => '\\StructType\\BillReceiverAddressType',
            'PaymentInfoType' => '\\StructType\\PaymentInfoType',
            'ShipmentChargeType' => '\\StructType\\ShipmentChargeType',
            'FRSPaymentInfoType' => '\\StructType\\FRSPaymentInfoType',
            'PaymentType' => '\\StructType\\PaymentType',
            'RateInfoType' => '\\StructType\\RateInfoType',
            'ReferenceNumberType' => '\\StructType\\ReferenceNumberType',
            'ServiceType' => '\\StructType\\ServiceType',
            'CurrencyMonetaryType' => '\\StructType\\CurrencyMonetaryType',
            'ShipmentServiceOptionsType' => '\\StructType\\ShipmentServiceOptionsType',
            'RestrictedArticlesType' => '\\StructType\\RestrictedArticlesType',
            'PreAlertNotificationType' => '\\StructType\\PreAlertNotificationType',
            'PreAlertEMailMessageType' => '\\StructType\\PreAlertEMailMessageType',
            'LocaleType' => '\\StructType\\LocaleType',
            'PreAlertVoiceMessageType' => '\\StructType\\PreAlertVoiceMessageType',
            'PreAlertTextMessageType' => '\\StructType\\PreAlertTextMessageType',
            'ContactInfoType' => '\\StructType\\ContactInfoType',
            'CODType' => '\\StructType\\CODType',
            'ShipmentServiceOptionsAccessPointCODType' => '\\StructType\\ShipmentServiceOptionsAccessPointCODType',
            'NotificationType' => '\\StructType\\NotificationType',
            'LabelDeliveryType' => '\\StructType\\LabelDeliveryType',
            'EmailDetailsType' => '\\StructType\\EmailDetailsType',
            'PackageType' => '\\StructType\\PackageType',
            'PackagingType' => '\\StructType\\PackagingType',
            'DimensionsType' => '\\StructType\\DimensionsType',
            'ShipUnitOfMeasurementType' => '\\StructType\\ShipUnitOfMeasurementType',
            'PackageWeightType' => '\\StructType\\PackageWeightType',
            'PackageServiceOptionsType' => '\\StructType\\PackageServiceOptionsType',
            'PackageDeclaredValueType' => '\\StructType\\PackageDeclaredValueType',
            'DeclaredValueType' => '\\StructType\\DeclaredValueType',
            'DeliveryConfirmationType' => '\\StructType\\DeliveryConfirmationType',
            'LabelMethodType' => '\\StructType\\LabelMethodType',
            'PSOCODType' => '\\StructType\\PSOCODType',
            'PackageServiceOptionsAccessPointCODType' => '\\StructType\\PackageServiceOptionsAccessPointCODType',
            'PSONotificationType' => '\\StructType\\PSONotificationType',
            'LabelSpecificationType' => '\\StructType\\LabelSpecificationType',
            'InstructionCodeDescriptionType' => '\\StructType\\InstructionCodeDescriptionType',
            'LabelImageFormatType' => '\\StructType\\LabelImageFormatType',
            'LabelStockSizeType' => '\\StructType\\LabelStockSizeType',
            'CommodityType' => '\\StructType\\CommodityType',
            'NMFCType' => '\\StructType\\NMFCType',
            'ShipmentResultsType' => '\\StructType\\ShipmentResultsType',
            'DisclaimerType' => '\\StructType\\DisclaimerType',
            'ShipmentChargesType' => '\\StructType\\ShipmentChargesType',
            'EstimatedDutiesAndTaxesType' => '\\StructType\\EstimatedDutiesAndTaxesType',
            'BrokerageFeesType' => '\\StructType\\BrokerageFeesType',
            'NegotiatedRateChargesType' => '\\StructType\\NegotiatedRateChargesType',
            'ShipChargeType' => '\\StructType\\ShipChargeType',
            'TaxChargeType' => '\\StructType\\TaxChargeType',
            'FRSShipmentDataType' => '\\StructType\\FRSShipmentDataType',
            'TransportationChargeType' => '\\StructType\\TransportationChargeType',
            'BillingWeightType' => '\\StructType\\BillingWeightType',
            'BillingUnitOfMeasurementType' => '\\StructType\\BillingUnitOfMeasurementType',
            'PackageResultsType' => '\\StructType\\PackageResultsType',
            'CommodityDutyChargesType' => '\\StructType\\CommodityDutyChargesType',
            'AccessorialType' => '\\StructType\\AccessorialType',
            'LabelType' => '\\StructType\\LabelType',
            'ReceiptType' => '\\StructType\\ReceiptType',
            'ImageType' => '\\StructType\\ImageType',
            'FormType' => '\\StructType\\FormType',
            'FormImageType' => '\\StructType\\FormImageType',
            'ImageFormatType' => '\\StructType\\ImageFormatType',
            'SCReportType' => '\\StructType\\SCReportType',
            'HighValueReportType' => '\\StructType\\HighValueReportType',
            'HazMatPackageInformationType' => '\\StructType\\HazMatPackageInformationType',
            'HazMatType' => '\\StructType\\HazMatType',
            'DryIceType' => '\\StructType\\DryIceType',
            'DryIceWeightType' => '\\StructType\\DryIceWeightType',
            'ReceiptSpecificationType' => '\\StructType\\ReceiptSpecificationType',
            'ReceiptImageFormatType' => '\\StructType\\ReceiptImageFormatType',
            'TaxIDCodeDescType' => '\\StructType\\TaxIDCodeDescType',
            'IndicationType' => '\\StructType\\IndicationType',
            'AlternateDeliveryAddressType' => '\\StructType\\AlternateDeliveryAddressType',
            'ShipmentServiceOptionsNotificationVoiceMessageType' => '\\StructType\\ShipmentServiceOptionsNotificationVoiceMessageType',
            'ShipmentServiceOptionsNotificationTextMessageType' => '\\StructType\\ShipmentServiceOptionsNotificationTextMessageType',
            'ADLAddressType' => '\\StructType\\ADLAddressType',
            'FreightShipmentInformationType' => '\\StructType\\FreightShipmentInformationType',
            'HandlingUnitsType' => '\\StructType\\HandlingUnitsType',
            'HandlingUnitsResponseType' => '\\StructType\\HandlingUnitsResponseType',
            'HandlingUnitsDimensionsType' => '\\StructType\\HandlingUnitsDimensionsType',
            'FreightDensityRateType' => '\\StructType\\FreightDensityRateType',
            'FreightDensityInfoType' => '\\StructType\\FreightDensityInfoType',
            'AdjustedHeightType' => '\\StructType\\AdjustedHeightType',
            'NegotiatedChargesType' => '\\StructType\\NegotiatedChargesType',
            'DGSignatoryInfoType' => '\\StructType\\DGSignatoryInfoType',
            'UPSPremierType' => '\\StructType\\UPSPremierType',
            'HandlingInstructionsType' => '\\StructType\\HandlingInstructionsType',
            'SimpleRateType' => '\\StructType\\SimpleRateType',
            'VendorInfoType' => '\\StructType\\VendorInfoType',
        );
    }
}
