<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AlternateDeliveryAddressType StructType
 * @subpackage Structs
 */
class AlternateDeliveryAddressType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The AttentionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AttentionName;
    /**
     * The UPSAccessPointID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UPSAccessPointID;
    /**
     * The Address
     * @var \StructType\ADLAddressType
     */
    public $Address;
    /**
     * Constructor method for AlternateDeliveryAddressType
     * @uses AlternateDeliveryAddressType::setName()
     * @uses AlternateDeliveryAddressType::setAttentionName()
     * @uses AlternateDeliveryAddressType::setUPSAccessPointID()
     * @uses AlternateDeliveryAddressType::setAddress()
     * @param string $name
     * @param string $attentionName
     * @param string $uPSAccessPointID
     * @param \StructType\ADLAddressType $address
     */
    public function __construct($name = null, $attentionName = null, $uPSAccessPointID = null, \StructType\ADLAddressType $address = null)
    {
        $this
            ->setName($name)
            ->setAttentionName($attentionName)
            ->setUPSAccessPointID($uPSAccessPointID)
            ->setAddress($address);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\AlternateDeliveryAddressType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get AttentionName value
     * @return string|null
     */
    public function getAttentionName()
    {
        return $this->AttentionName;
    }
    /**
     * Set AttentionName value
     * @param string $attentionName
     * @return \StructType\AlternateDeliveryAddressType
     */
    public function setAttentionName($attentionName = null)
    {
        // validation for constraint: string
        if (!is_null($attentionName) && !is_string($attentionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attentionName, true), gettype($attentionName)), __LINE__);
        }
        $this->AttentionName = $attentionName;
        return $this;
    }
    /**
     * Get UPSAccessPointID value
     * @return string|null
     */
    public function getUPSAccessPointID()
    {
        return $this->UPSAccessPointID;
    }
    /**
     * Set UPSAccessPointID value
     * @param string $uPSAccessPointID
     * @return \StructType\AlternateDeliveryAddressType
     */
    public function setUPSAccessPointID($uPSAccessPointID = null)
    {
        // validation for constraint: string
        if (!is_null($uPSAccessPointID) && !is_string($uPSAccessPointID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uPSAccessPointID, true), gettype($uPSAccessPointID)), __LINE__);
        }
        $this->UPSAccessPointID = $uPSAccessPointID;
        return $this;
    }
    /**
     * Get Address value
     * @return \StructType\ADLAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \StructType\ADLAddressType $address
     * @return \StructType\AlternateDeliveryAddressType
     */
    public function setAddress(\StructType\ADLAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
}
