<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactInfoType StructType
 * @subpackage Structs
 */
class ContactInfoType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Phone
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ShipPhoneType
     */
    public $Phone;
    /**
     * Constructor method for ContactInfoType
     * @uses ContactInfoType::setName()
     * @uses ContactInfoType::setPhone()
     * @param string $name
     * @param \StructType\ShipPhoneType $phone
     */
    public function __construct($name = null, \StructType\ShipPhoneType $phone = null)
    {
        $this
            ->setName($name)
            ->setPhone($phone);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\ContactInfoType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Phone value
     * @return \StructType\ShipPhoneType|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param \StructType\ShipPhoneType $phone
     * @return \StructType\ContactInfoType
     */
    public function setPhone(\StructType\ShipPhoneType $phone = null)
    {
        $this->Phone = $phone;
        return $this;
    }
}
