<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactType StructType
 * @subpackage Structs
 */
class ContactType extends AbstractStructBase
{
    /**
     * The ForwardAgent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ForwardAgentType
     */
    public $ForwardAgent;
    /**
     * The UltimateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\UltimateConsigneeType
     */
    public $UltimateConsignee;
    /**
     * The IntermediateConsignee
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\IntermediateConsigneeType
     */
    public $IntermediateConsignee;
    /**
     * The Producer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ProducerType
     */
    public $Producer;
    /**
     * The SoldTo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SoldToType
     */
    public $SoldTo;
    /**
     * Constructor method for ContactType
     * @uses ContactType::setForwardAgent()
     * @uses ContactType::setUltimateConsignee()
     * @uses ContactType::setIntermediateConsignee()
     * @uses ContactType::setProducer()
     * @uses ContactType::setSoldTo()
     * @param \StructType\ForwardAgentType $forwardAgent
     * @param \StructType\UltimateConsigneeType $ultimateConsignee
     * @param \StructType\IntermediateConsigneeType $intermediateConsignee
     * @param \StructType\ProducerType $producer
     * @param \StructType\SoldToType $soldTo
     */
    public function __construct(\StructType\ForwardAgentType $forwardAgent = null, \StructType\UltimateConsigneeType $ultimateConsignee = null, \StructType\IntermediateConsigneeType $intermediateConsignee = null, \StructType\ProducerType $producer = null, \StructType\SoldToType $soldTo = null)
    {
        $this
            ->setForwardAgent($forwardAgent)
            ->setUltimateConsignee($ultimateConsignee)
            ->setIntermediateConsignee($intermediateConsignee)
            ->setProducer($producer)
            ->setSoldTo($soldTo);
    }
    /**
     * Get ForwardAgent value
     * @return \StructType\ForwardAgentType|null
     */
    public function getForwardAgent()
    {
        return $this->ForwardAgent;
    }
    /**
     * Set ForwardAgent value
     * @param \StructType\ForwardAgentType $forwardAgent
     * @return \StructType\ContactType
     */
    public function setForwardAgent(\StructType\ForwardAgentType $forwardAgent = null)
    {
        $this->ForwardAgent = $forwardAgent;
        return $this;
    }
    /**
     * Get UltimateConsignee value
     * @return \StructType\UltimateConsigneeType|null
     */
    public function getUltimateConsignee()
    {
        return $this->UltimateConsignee;
    }
    /**
     * Set UltimateConsignee value
     * @param \StructType\UltimateConsigneeType $ultimateConsignee
     * @return \StructType\ContactType
     */
    public function setUltimateConsignee(\StructType\UltimateConsigneeType $ultimateConsignee = null)
    {
        $this->UltimateConsignee = $ultimateConsignee;
        return $this;
    }
    /**
     * Get IntermediateConsignee value
     * @return \StructType\IntermediateConsigneeType|null
     */
    public function getIntermediateConsignee()
    {
        return $this->IntermediateConsignee;
    }
    /**
     * Set IntermediateConsignee value
     * @param \StructType\IntermediateConsigneeType $intermediateConsignee
     * @return \StructType\ContactType
     */
    public function setIntermediateConsignee(\StructType\IntermediateConsigneeType $intermediateConsignee = null)
    {
        $this->IntermediateConsignee = $intermediateConsignee;
        return $this;
    }
    /**
     * Get Producer value
     * @return \StructType\ProducerType|null
     */
    public function getProducer()
    {
        return $this->Producer;
    }
    /**
     * Set Producer value
     * @param \StructType\ProducerType $producer
     * @return \StructType\ContactType
     */
    public function setProducer(\StructType\ProducerType $producer = null)
    {
        $this->Producer = $producer;
        return $this;
    }
    /**
     * Get SoldTo value
     * @return \StructType\SoldToType|null
     */
    public function getSoldTo()
    {
        return $this->SoldTo;
    }
    /**
     * Set SoldTo value
     * @param \StructType\SoldToType $soldTo
     * @return \StructType\ContactType
     */
    public function setSoldTo(\StructType\SoldToType $soldTo = null)
    {
        $this->SoldTo = $soldTo;
        return $this;
    }
}
