<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HandlingInstructionsType StructType
 * @subpackage Structs
 */
class HandlingInstructionsType extends AbstractStructBase
{
    /**
     * The Instruction
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var string[]
     */
    public $Instruction;
    /**
     * Constructor method for HandlingInstructionsType
     * @uses HandlingInstructionsType::setInstruction()
     * @param string[] $instruction
     */
    public function __construct(array $instruction = array())
    {
        $this
            ->setInstruction($instruction);
    }
    /**
     * Get Instruction value
     * @return string[]|null
     */
    public function getInstruction()
    {
        return $this->Instruction;
    }
    /**
     * This method is responsible for validating the values passed to the setInstruction method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInstruction method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInstructionForArrayConstraintsFromSetInstruction(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $handlingInstructionsTypeInstructionItem) {
            // validation for constraint: itemType
            if (!is_string($handlingInstructionsTypeInstructionItem)) {
                $invalidValues[] = is_object($handlingInstructionsTypeInstructionItem) ? get_class($handlingInstructionsTypeInstructionItem) : sprintf('%s(%s)', gettype($handlingInstructionsTypeInstructionItem), var_export($handlingInstructionsTypeInstructionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Instruction property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Instruction value
     * @throws \InvalidArgumentException
     * @param string[] $instruction
     * @return \StructType\HandlingInstructionsType
     */
    public function setInstruction(array $instruction = array())
    {
        // validation for constraint: array
        if ('' !== ($instructionArrayErrorMessage = self::validateInstructionForArrayConstraintsFromSetInstruction($instruction))) {
            throw new \InvalidArgumentException($instructionArrayErrorMessage, __LINE__);
        }
        $this->Instruction = $instruction;
        return $this;
    }
    /**
     * Add item to Instruction value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\HandlingInstructionsType
     */
    public function addToInstruction($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The Instruction property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Instruction[] = $item;
        return $this;
    }
}
